import * as ts from 'typescript';
import * as camelcase from 'camelcase';
import { BaseClientInterpreter, IWriter, InterpreterData, IClientMetadata } from '..';
import {
  IControllerData,
  TypeData,
  IControllerRoute,
  IControllerRouteMethod,
  IUnionData,
  IEnumData,
  IInterfaceData,
  IClassData,
  ReferencableTypeData,
  IPropertyData,
  IIntersectionData,
  IOpaqueTypeImplementationData,
  IOpaqueTypeDefinitionData,
} from '../../types/metadata';
import { assertNever } from '../../utils';

export class TypescriptInterpreter extends BaseClientInterpreter {
  private controllers: IControllerData[] = [];

  private types: TypeData[] = [];

  private printerSourceFile: ts.SourceFile;

  private printer: ts.Printer;

  private isInitialised = false;

  constructor(writer: IWriter, metadata: IClientMetadata, private isMonoParams: boolean) {
    super(writer, metadata);

    this.printer = ts.createPrinter({ newLine: ts.NewLineKind.LineFeed });
    this.printerSourceFile = ts.createSourceFile('', '', ts.ScriptTarget.Latest, false, ts.ScriptKind.TS);
  }

  private async printNode(node: ts.Node): Promise<void> {
    await this.writer.write(`${this.printer.printNode(ts.EmitHint.Unspecified, node, this.printerSourceFile)}\n\n`);
  }

  private async initialise(): Promise<void> {
    await this.writer.write(
      '/* tslint:disable */\n/* eslint-disable */\n/* prettier-ignore */\n// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.\n\n'
    );

    // Create header
    await this.printNode(
      ts.createInterfaceDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        'HeaderMap',
        [],
        [],
        [
          ts.createIndexSignature(
            [],
            [],
            [
              ts.createParameter(
                [],
                [],
                undefined,
                'k',
                undefined,
                ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword)
              ),
            ],
            ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword)
          ),
        ]
      )
    );

    // Create fetcher
    await this.printNode(
      ts.createInterfaceDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        'IFetcher',
        [],
        [],
        [
          ts.createMethodSignature(
            [ts.createTypeParameterDeclaration('T')],
            [
              ts.createParameter(
                [],
                [],
                undefined,
                'url',
                undefined,
                ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword)
              ),
              ts.createParameter(
                [],
                [],
                undefined,
                'verb',
                undefined,
                ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword)
              ),
              ts.createParameter(
                [],
                [],
                undefined,
                'contentType',
                undefined,
                ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword)
              ),
              ts.createParameter(
                [],
                [],
                undefined,
                'body',
                ts.createToken(ts.SyntaxKind.QuestionToken),
                ts.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword)
              ),
              ts.createParameter(
                [],
                [],
                undefined,
                'headers',
                ts.createToken(ts.SyntaxKind.QuestionToken),
                ts.createTypeReferenceNode('HeaderMap', [])
              ),
            ],
            ts.createTypeReferenceNode('Promise', [ts.createTypeReferenceNode('T', [])]),
            'request',
            undefined
          ),
          ts.createMethodSignature(
            [],
            [
              ts.createParameter(
                [],
                [],
                undefined,
                'query',
                ts.createToken(ts.SyntaxKind.QuestionToken),
                ts.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword)
              ),
            ],
            ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword),
            'buildQueryString',
            undefined
          ),
          ts.createMethodSignature(
            undefined,
            [
              ts.createParameter(
                undefined,
                undefined,
                undefined,
                ts.createIdentifier('routeUniqueName'),
                undefined,
                ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword),
                undefined
              ),
              ts.createParameter(
                undefined,
                undefined,
                undefined,
                ts.createIdentifier('paramValues'),
                undefined,
                ts.createTypeLiteralNode([
                  ts.createPropertySignature(
                    undefined,
                    ts.createIdentifier('body'),
                    ts.createToken(ts.SyntaxKind.QuestionToken),
                    ts.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),
                    undefined
                  ),
                  ts.createPropertySignature(
                    undefined,
                    ts.createIdentifier('params'),
                    ts.createToken(ts.SyntaxKind.QuestionToken),
                    ts.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),
                    undefined
                  ),
                  ts.createPropertySignature(
                    undefined,
                    ts.createIdentifier('query'),
                    ts.createToken(ts.SyntaxKind.QuestionToken),
                    ts.createKeywordTypeNode(ts.SyntaxKind.AnyKeyword),
                    undefined
                  ),
                ]),
                undefined
              ),
            ],
            ts.createTypeReferenceNode(ts.createIdentifier('Promise'), [
              ts.createKeywordTypeNode(ts.SyntaxKind.VoidKeyword),
            ]),
            ts.createIdentifier('requestValidate'),
            ts.createToken(ts.SyntaxKind.QuestionToken)
          ),
        ]
      )
    );
  }

  private async writeUnion(data: IUnionData): Promise<void> {
    await this.printNode(
      ts.createTypeAliasDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        data.name,
        [],
        ts.createUnionTypeNode(data.options.map(o => ts.createTypeReferenceNode(this.getReferenceName(o), [])))
      )
    );
  }

  private async writeIntersection(data: IIntersectionData): Promise<void> {
    await this.printNode(
      ts.createTypeAliasDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        data.name,
        [],
        ts.createIntersectionTypeNode(data.options.map(o => ts.createTypeReferenceNode(this.getReferenceName(o), [])))
      )
    );
  }

  private async writeEnum(data: IEnumData): Promise<void> {
    await this.printNode(
      ts.createEnumDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        data.name,
        data.values.map(v => ts.createEnumMember(v.key, ts.createLiteral(v.value)))
      )
    );
  }

  private createHeritageClauses(data: IClassData | IInterfaceData) {
    const extendClauses: ts.ExpressionWithTypeArguments[] = [];
    const implementsClauses: ts.ExpressionWithTypeArguments[] = [];

    for (const baseType of data.baseTypes) {
      const expression: ts.ExpressionWithTypeArguments = ts.createExpressionWithTypeArguments(
        [],
        ts.createIdentifier(this.getReferenceName(baseType))
      );
      if (data.kind === 'class' && baseType.kind === 'reference' && baseType.reference.kind === 'interface') {
        implementsClauses.push(expression);
      } else {
        extendClauses.push(expression);
      }
    }

    const clauses: ts.HeritageClause[] = [];
    if (extendClauses.length > 0) {
      clauses.push(ts.createHeritageClause(ts.SyntaxKind.ExtendsKeyword, extendClauses));
    }

    if (implementsClauses.length > 0) {
      clauses.push(ts.createHeritageClause(ts.SyntaxKind.ImplementsKeyword, implementsClauses));
    }

    return clauses;
  }

  private createClassElement(data: IPropertyData): ts.PropertyDeclaration {
    return ts.createProperty(
      [],
      [],
      data.name,
      data.isNullable ? ts.createToken(ts.SyntaxKind.QuestionToken) : undefined,
      ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(data.type)), undefined),
      undefined
    );
  }

  private createClassElements(data: IClassData): ts.PropertyDeclaration[] {
    const properties = data.properties.map(property => this.createClassElement(property));

    for (const baseType of data.baseTypes) {
      if (baseType.kind === 'reference' && baseType.reference.kind === 'interface') {
        const interfaceDefinition = this.types.find(x => x.kind === 'interface' && x.name === baseType.reference.name);
        if (!interfaceDefinition) {
          throw new Error(`Failed to find type for '${baseType.reference.name}' of type '${baseType.reference.kind}'`);
        }

        properties.push(...this.createClassElements(interfaceDefinition as IClassData));
      }
    }

    return properties;
  }

  private async writeClass(data: IClassData): Promise<void> {
    await this.printNode(
      ts.createClassDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        data.name,
        [],
        this.createHeritageClauses(data),
        this.createClassElements(data)
      )
    );
  }

  private createTypeElement(data: IPropertyData): ts.PropertySignature {
    return ts.createPropertySignature(
      [],
      data.name,
      data.isNullable ? ts.createToken(ts.SyntaxKind.QuestionToken) : undefined,
      ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(data.type)), undefined),
      undefined
    );
  }

  private async writeInterface(data: IInterfaceData): Promise<void> {
    await this.printNode(
      ts.createInterfaceDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        data.name,
        [],
        this.createHeritageClauses(data),
        data.properties.map(property => this.createTypeElement(property))
      )
    );
  }

  private async writeOpaqueTypeDefinition(data: IOpaqueTypeDefinitionData): Promise<void> {
    await this.printNode(
      ts.createTypeAliasDeclaration(
        undefined,
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        ts.createIdentifier(data.name),
        [
          ts.createTypeParameterDeclaration(
            ts.createIdentifier('Key'),
            ts.createKeywordTypeNode(ts.SyntaxKind.StringKeyword),
            undefined
          ),
        ],
        ts.createIntersectionTypeNode([
          ts.createTypeReferenceNode(data.type.name, []),
          ts.createTypeLiteralNode([
            ts.createPropertySignature(
              undefined,
              ts.createIdentifier('__opaque'),
              undefined,
              ts.createTypeReferenceNode(ts.createIdentifier('Key'), undefined),
              undefined
            ),
          ]),
        ])
      )
    );
  }

  private async writeOpaqueTypeImplementation(data: IOpaqueTypeImplementationData): Promise<void> {
    await this.printNode(
      ts.createTypeAliasDeclaration(
        undefined,
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        ts.createIdentifier(data.name),
        undefined,
        ts.createTypeReferenceNode(ts.createIdentifier(data.type.name), [
          ts.createLiteralTypeNode(ts.createStringLiteral(data.key.name)),
        ])
      )
    );
  }

  public async write(data: InterpreterData): Promise<void> {
    if (this.isInitialised === false) {
      await this.initialise();
      this.isInitialised = true;
    }

    switch (data.kind) {
      case 'union':
        await this.writeUnion(data);
        break;
      case 'enum':
        await this.writeEnum(data);
        break;
      case 'class':
        await this.writeClass(data);
        break;
      case 'interface':
        this.types.push(data);
        await this.writeInterface(data);
        break;
      case 'intersection':
        await this.writeIntersection(data);
        break;
      case 'opaque-type-def':
        await this.writeOpaqueTypeDefinition(data);
        break;
      case 'opaque-type-impl':
        await this.writeOpaqueTypeImplementation(data);
        break;
      case 'literal':
      case 'qualified-type':
        this.types.push(data);
        break;
      case 'controller':
        this.controllers.push(data);
        break;
      default:
        assertNever(data, 'Unexpected data kind');
    }
  }

  private getReferenceName(data: TypeData | ReferencableTypeData): string {
    if (data.kind === 'array') {
      return `${this.getReferenceName(data.type)}[]`;
    }
    if (data.kind === 'reference') {
      return data.reference.name;
    }
    if (data.kind === 'qualified-type' && data.type.kind === 'literal') {
      return `'${data.value}'`;
    }

    return data.name;
  }

  private cleanPath(routePath: string) {
    const regex = /:([^/]+)(\/|$)/g;

    const matches = routePath.match(regex);
    let cleanedPath = routePath;
    if (matches) {
      for (const match of matches) {
        const endWithSlash = match.endsWith('/');
        cleanedPath = cleanedPath.replace(
          match,
          `\${${this.isMonoParams ? 'request.params' : 'params'}.${match
            .replace(':', '')
            .replace('/', '')
            .replace(/\?$/, '')}}${endWithSlash ? '/' : ''}`
        );
      }
    }

    return cleanedPath;
  }

  private createRoute(
    controller: IControllerData,
    route: IControllerRoute,
    method: IControllerRouteMethod
  ): ts.ClassElement {
    let parameters: ts.ParameterDeclaration[] = [];
    const monoParameters: ts.TypeElement[] = [];
    if (method.body) {
      if (this.isMonoParams) {
        monoParameters.push(
          ts.createPropertySignature(
            undefined,
            'body',
            undefined,
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.body)), undefined),
            undefined
          )
        );
      } else {
        parameters.push(
          ts.createParameter(
            undefined,
            undefined,
            undefined,
            ts.createIdentifier('body'),
            undefined,
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.body)), undefined),
            undefined
          )
        );
      }
    }

    let response = 'void';
    if (method.response) {
      response = this.getReferenceName(method.response);
    }

    let path = this.cleanPath(`${controller.root}/${route.path}`);

    if (method.params) {
      if (this.isMonoParams) {
        monoParameters.push(
          ts.createPropertySignature(
            undefined,
            'params',
            undefined,
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.params)), undefined),
            undefined
          )
        );
      } else {
        parameters.push(
          ts.createParameter(
            undefined,
            undefined,
            undefined,
            ts.createIdentifier('params'),
            undefined,
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.params)), undefined),
            undefined
          )
        );
      }
    }

    if (method.query) {
      if (this.isMonoParams) {
        monoParameters.push(
          ts.createPropertySignature(
            undefined,
            'query',
            ts.createToken(ts.SyntaxKind.QuestionToken),
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.query)), undefined),
            undefined
          )
        );

        // eslint-disable-next-line no-template-curly-in-string
        path += '${this.fetcher.buildQueryString(request.query)}';
      } else {
        parameters.push(
          ts.createParameter(
            undefined,
            undefined,
            undefined,
            ts.createIdentifier('query'),
            ts.createToken(ts.SyntaxKind.QuestionToken),
            ts.createTypeReferenceNode(ts.createIdentifier(this.getReferenceName(method.query)), undefined),
            undefined
          )
        );

        // eslint-disable-next-line no-template-curly-in-string
        path += '${this.fetcher.buildQueryString(query)}';
      }
    }

    // Always support additional headers
    if (this.isMonoParams) {
      monoParameters.push(
        ts.createPropertySignature(
          undefined,
          'headers',
          ts.createToken(ts.SyntaxKind.QuestionToken),
          ts.createTypeReferenceNode(ts.createIdentifier('HeaderMap'), undefined),
          undefined
        )
      );
    } else {
      parameters.push(
        ts.createParameter(
          undefined,
          undefined,
          undefined,
          ts.createIdentifier('headers'),
          ts.createToken(ts.SyntaxKind.QuestionToken),
          ts.createTypeReferenceNode(ts.createIdentifier('HeaderMap'), undefined),
          undefined
        )
      );
    }

    if (this.isMonoParams) {
      parameters = [
        ts.createParameter(
          undefined,
          undefined,
          undefined,
          ts.createIdentifier('request'),
          undefined,
          ts.createTypeLiteralNode(monoParameters),
          undefined
        ),
      ];
    }

    return ts.createProperty(
      undefined,
      undefined,
      ts.createIdentifier(method.name),
      undefined,
      undefined,
      ts.createArrowFunction(
        [],
        undefined,
        parameters,
        ts.createTypeReferenceNode(ts.createIdentifier('Promise'), [
          ts.createTypeReferenceNode(ts.createIdentifier(response), undefined),
        ]),
        ts.createToken(ts.SyntaxKind.EqualsGreaterThanToken),
        ts.createBlock(
          [
            ts.createReturn(
              ts.createCall(
                ts.createPropertyAccess(
                  ts.createPropertyAccess(ts.createThis(), ts.createIdentifier('fetcher')),
                  ts.createIdentifier('request')
                ),
                [ts.createTypeReferenceNode(ts.createIdentifier(response), undefined)],
                [
                  ts.createNoSubstitutionTemplateLiteral(path, path),
                  ts.createStringLiteral(method.method),
                  ts.createStringLiteral(method.contentType),
                  method.body
                    ? ts.createIdentifier(this.isMonoParams ? 'request.body' : 'body')
                    : ts.createIdentifier('undefined'),
                  ts.createIdentifier(this.isMonoParams ? 'request.headers' : 'headers'),
                ]
              )
            ),
          ],
          true
        )
      )
    );
  }

  public async finalise(): Promise<void> {
    const controllerApiElements: ts.ClassElement[] = [];

    for (const controller of this.controllers) {
      const routeElements: ts.ClassElement[] = [];
      for (const route of controller.routes) {
        for (const method of route.methods) {
          routeElements.push(this.createRoute(controller, route, method));
        }
      }

      await this.printNode(
        ts.createClassDeclaration(
          [],
          [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
          `${controller.name}Controller`,
          [],
          [],
          [
            ts.createConstructor(
              undefined,
              undefined,
              [
                ts.createParameter(
                  undefined,
                  [ts.createModifier(ts.SyntaxKind.PrivateKeyword)],
                  undefined,
                  ts.createIdentifier('fetcher'),
                  undefined,
                  ts.createTypeReferenceNode(ts.createIdentifier('IFetcher'), undefined),
                  undefined
                ),
              ],
              ts.createBlock([], false)
            ),
            ...routeElements,
          ]
        )
      );

      // Add Api client property
      controllerApiElements.push(
        ts.createProperty(
          undefined,
          undefined,
          ts.createIdentifier(camelcase(controller.name)),
          undefined,
          undefined,
          ts.createNew(ts.createIdentifier(`${controller.name}Controller`), undefined, [
            ts.createPropertyAccess(ts.createThis(), ts.createIdentifier('fetcher')),
          ])
        )
      );
    }

    await this.printNode(
      ts.createClassDeclaration(
        [],
        [ts.createModifier(ts.SyntaxKind.ExportKeyword)],
        'ApiClient',
        [],
        [],
        [
          ts.createConstructor(
            undefined,
            undefined,
            [
              ts.createParameter(
                undefined,
                [ts.createModifier(ts.SyntaxKind.PrivateKeyword)],
                undefined,
                ts.createIdentifier('fetcher'),
                undefined,
                ts.createTypeReferenceNode(ts.createIdentifier('IFetcher'), undefined),
                undefined
              ),
            ],
            ts.createBlock([], false)
          ),
          ...controllerApiElements,
        ]
      )
    );

    return Promise.resolve();
  }
}
